#%Module

set fn      $ModulesCurrentModulefile
set fn      [file normalize $ModulesCurrentModulefile]

if {[file type $fn] eq "link"} {
   set fn [ exec readlink -f $fn]
}

set mydir_base  [ file dirname $fn ]
set mydir_base  [ file dirname $mydir_base ]
set mydir       [ file normalize $mydir_base ]
set hpcx_dir        $mydir
set hpcx_mpi_dir    $hpcx_dir/ompi-v3.0.x

module-whatis   Mellanox HPC-X toolkit

setenv HPCX_DIR             $hpcx_dir
setenv HPCX_HOME            $hpcx_dir

setenv HPCX_FCA_DIR         $hpcx_dir/fca
setenv HPCX_MXM_DIR         $hpcx_dir/mxm
setenv HPCX_UCX_DIR         $hpcx_dir/ucx
setenv HPCX_SHARP_DIR       $hpcx_dir/sharp
setenv HPCX_HCOLL_DIR       $hpcx_dir/hcoll

# legacy vars
setenv FCA_DIR         $hpcx_dir/fca
setenv MXM_DIR         $hpcx_dir/mxm
setenv UCX_DIR         $hpcx_dir/ucx
setenv SHARP_DIR       $hpcx_dir/sharp
setenv HCOLL_DIR       $hpcx_dir/hcoll

setenv HPCX_IBPROF_DIR      $hpcx_dir/ibprof
setenv HPCX_IBPROF_LIB      $hpcx_dir/ibprof/lib/libibprof.so
setenv HPCX_BUPC_DIR        $hpcx_dir/bupc
setenv HPCX_MPI_DIR         $hpcx_mpi_dir
setenv HPCX_OSHMEM_DIR      $hpcx_mpi_dir
setenv HPCX_IPM_DIR         $hpcx_mpi_dir/tests/ipm-2.0.6
setenv HPCX_IPM_LIB         $hpcx_mpi_dir/tests/ipm-2.0.6/lib/libipm.so
setenv HPCX_MPI_TESTS_DIR   $hpcx_mpi_dir/tests


prepend-path    PATH    $hpcx_dir/mxm/bin
prepend-path    PATH    $hpcx_dir/ucx/bin
prepend-path    PATH    $hpcx_dir/hcoll/bin
prepend-path    PATH    $hpcx_dir/bupc/bin
prepend-path    PATH    $hpcx_mpi_dir/tests/imb

prepend-path    LD_LIBRARY_PATH $hpcx_dir/mxm/lib
prepend-path    LD_LIBRARY_PATH $hpcx_dir/ucx/lib
prepend-path    LD_LIBRARY_PATH $hpcx_dir/hcoll/lib
prepend-path    LD_LIBRARY_PATH $hpcx_dir/fca/lib
prepend-path    LD_LIBRARY_PATH $hpcx_dir/sharp/lib

prepend-path    LIBRARY_PATH $hpcx_dir/mxm/lib
prepend-path    LIBRARY_PATH $hpcx_dir/ucx/lib
prepend-path    LIBRARY_PATH $hpcx_dir/hcoll/lib
prepend-path    LIBRARY_PATH $hpcx_dir/sharp/lib

prepend-path    CPATH   $hpcx_dir/hcoll/include
prepend-path    CPATH   $hpcx_dir/mxm/include
prepend-path    CPATH   $hpcx_dir/sharp/include
prepend-path    CPATH   $hpcx_dir/ucx/include
prepend-path    CPATH   $hpcx_mpi_dir/include

prepend-path    MANPATH         $hpcx_mpi_dir/share/man

# Adding MPI runtime

setenv OPAL_PREFIX          $hpcx_mpi_dir
setenv PMIX_INSTALL_PREFIX  $hpcx_mpi_dir
setenv OMPI_HOME            $hpcx_mpi_dir
setenv MPI_HOME             $hpcx_mpi_dir
setenv OSHMEM_HOME          $hpcx_mpi_dir
setenv SHMEM_HOME           $hpcx_mpi_dir

prepend-path    PATH    $hpcx_mpi_dir/bin
prepend-path    LD_LIBRARY_PATH $hpcx_mpi_dir/lib
prepend-path    LIBRARY_PATH $hpcx_mpi_dir/lib
